Imports System.Globalization

Public Class fecharestaForm
    Inherits System.Web.UI.Page

#Region " Cdigo generado por el Diseador de Web Forms "

    'El Diseador de Web Forms requiere esta llamada.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected WithEvents ListMes As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ListDia As System.Web.UI.WebControls.DropDownList
    Protected WithEvents ListYear As System.Web.UI.WebControls.DropDownList
    Protected WithEvents LbHoy As System.Web.UI.WebControls.Label
    Protected WithEvents LbDiff As System.Web.UI.WebControls.Label
    Protected WithEvents LbAviso As System.Web.UI.WebControls.Label

    ' variables para la fecha (da, mes y ao)
    Protected f As DateTime

    'NOTA: el Diseador de Web Forms necesita la siguiente declaracin del marcador de posicin.
    'No se debe eliminar o mover.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: el Diseador de Web Forms requiere esta llamada de mtodo
        'No la modifique con el editor de cdigo.
        InitializeComponent()
    End Sub

#End Region

    'al cargar la pgina aspx
    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            If Not Page.IsPostBack Then
                'declaraciones y asignaciones de fechas, Now es la fecha actual
                f = Now
                '
                'la fecha se puede formatear para ser presentada de diferentes maneras
                '- DateTime.Now.ToString("dddd, d/MMMM/yyyy") produce mircoles, 12/junio/2019
                '- DateTime.Now.ToString("d/MMMM/yyyy") produce 12/junio/2019
                '- se puede personalizar para una configuracin regional determinada importando using System.Globalization,
                'inicializando una instancia de la clase CultureInfo y pasndola como segundo parmetro 
                'DateTime.Now.ToString("D", esC) que produce mircoles, 12 de junio de 2019
                Dim esC As CultureInfo = New CultureInfo("es-ES")
                LbHoy.Text = DateTime.Now.ToString("D", esC)
                'LbHoy.Text = DateTime.Now.ToString("dddd, d/MMMM/yyyy")
                'otra forma de formatear la etiqueta
                'LbHoy.Text = Format(f, "d/MMMM/yyyy")
                '
                '2 maneras de asignar valores de fecha directamente a la variable
                'Dim f1 As New Date(2004, 12, 31)
                'Dim f2 As Date = Convert.ToDateTime("31 diciembre, 2004")
                '
                ' Cdigo para hacer que los cuados de lista arranquen con la fecha actual
                ' la propiedad Now devuelve el mes como entero de 1 a 12 pero as no lo captura bien la lista desplegable de los meses de la pgina aspx
                ' convertimos el n en el nombre del mes con la primera letra en maysculas para que coincida exactamente con el nombre del mes
                Dim mes As String
                mes = f.ToString("MMMM")
                mes = mes.Substring(0, 1).ToUpper() & mes.Substring(1).ToLower()
                ListDia.SelectedValue = CType(f.Day, String)
                ListMes.SelectedValue = mes
                ListYear.SelectedValue = CType(f.Year, String)
                '
                Call Diferencia() 'mtodo que hace los clculos

                LbAviso.Text = ""
            End If
        Catch pollo As Exception
            LbDiff.Text = ""
            LbAviso.Text = "ERROR: " & pollo.Message
        End Try
    End Sub

    'mtodo que realiza el clculo y lo muestra
    Sub Diferencia()
        Try
            ' para avisar al seleccionar un da incorrecto segn el mes elegido
            Dim ordenMes As Integer
            ordenMes = ListMes.SelectedIndex 'mes seleccionado
            Dim valorDia As Integer
            valorDia = CInt(ListDia.SelectedValue) 'da seleccionado
            Dim valorAo As Integer
            valorAo = CInt(ListYear.SelectedValue) 'ao seleccionado
            ' dependiendo delda seleccionado
            Select Case ordenMes
                Case 1 'mes febrero
                    If Not (valorAo Mod 4 = 0 And valorAo Mod 400 = 0) Then 'si no es bisiesto
                        If (valorDia > 28) Then
                            LbDiff.Text = ""
                            LbAviso.Text = "ERROR: Febrero tiene 28 das!"
                            Return
                        End If
                    Else 'si es bisiesto
                        If (valorDia > 29) Then
                            LbDiff.Text = ""
                            LbAviso.Text = "ERROR: Febrero bisiesto tiene 29 das!"
                            Return
                        End If
                    End If
                Case 3, 5, 8, 10 'meses de 30 das
                    If (valorDia > 30) Then
                        LbDiff.Text = ""
                        LbAviso.Text = "ERROR: Este mes slo tiene 30 das!"
                        Return
                    End If
            End Select
            'crear una fecha a partir de los valores seleccionados en las listas desplegables
            'equivalente a escribir: Dim fa As Date = Convert.ToDateTime("da mes, ao")
            Dim fa As Date = Convert.ToDateTime(ListDia.SelectedValue &
            " " & ListMes.SelectedValue & ", " & ListYear.SelectedValue)
            'variable para almacenar la diferencia de fechas
            Dim fb As Long
            fb = DateDiff(DateInterval.Day, Date.Today, fa)
            'para evitar que la cifra salga como n negativo cuando fa es anterior a hoy
            If fb < 0 Then
                fb = (-fb)
            End If
            'mostrar la diferencia en das
            LbDiff.Text = "<font size=2 color=black>Das que separan el da de hoy " &
            "de la fecha seleccionada: </font><b>" & fb & "</b>"
            LbAviso.Text = ""
        Catch pollo As Exception
            LbDiff.Text = ""
            LbAviso.Text = "ERROR: " & pollo.Message
        End Try
    End Sub

    'al cambiar el tem seleccionado en las listas desplegables se llama al clculo de los das
    Private Sub ListDia_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListDia.SelectedIndexChanged
        Call Diferencia()
    End Sub

    Private Sub ListMes_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListMes.SelectedIndexChanged
        Call Diferencia()
    End Sub

    Private Sub ListYear_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListYear.SelectedIndexChanged
        Call Diferencia()
    End Sub

End Class
